﻿using System;

namespace meise
{
  public class Game
  {

    static void Main()
    {
      Map mapInstance = new Map();
      Armeise armeise = new Armeise();
      mapInstance.DrawMap(armeise.posX, armeise.posY);

      armeise.TurnLeft();
      armeise.TurnLeft();
    }
  }

  public class Map
  {
    public int sizeY = 10;
    public int sizeX = 10;

    // Draws map line by line, replacing the V wit A if ant there
    public void DrawMap(int armeiseX, int armeiseY)
    {
      for (int i = 0; i <= sizeY; i++)
      {
        for (int j = 0; j <= sizeX; j++)
        {
          if (i == armeiseY && j == armeiseX)
          {
            Console.Write('A');
          }
          else
          {
            Console.Write('V');
          }
        }
        Console.WriteLine();
      }
      Console.WriteLine();
    }
  }

  public class Armeise
  {
    public int posY { get; set; }
    public int posX { get; set; }
    public Directions directionFacing { get; set; }
    // Enum to have it obviousè what way turning
    public enum Directions
    {
      North,
      East,
      South,
      West
    }

    public Armeise(int x = 0, int y = 0)
    {
      posX = x;
      posY = y;
      directionFacing = Directions.East;
    }

    public void MoveRandom(int borderX, int borderY)
    {
      int minMove = 2;
      int maxMove = 6;
      int test = 3;
    }

    public void Move(int steps)
    {
      switch (directionFacing)
      {
        case Directions.North:
          posY -= steps;
          break;
        case Directions.East:
          posX += steps;
          break;
        case Directions.South:
          posY += steps;
          break;
        case Directions.West:
          posX -= steps;
          break;
        default:
          break;
      }
    }
    // Moves the direction one up or down in the enum
    // Prevents ant from U-Turn and need modulo wrapping for north to west
    public void TurnRight()
    {
      directionFacing = (Directions)(((int)directionFacing + 1) % 4);
    }
    public void TurnLeft()
    {
      directionFacing = (Directions)(((int)directionFacing - 1 + 4) % 4);
    }
  }
}